moMissions = {};
source(MultiOverlayV3.modDir.."scripte/module/missions/moMissionsConfig.lua");

function moMissions:update(dt)
	if moModule.active.missions.isRunning then
		if moMissions.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateMissions"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moMissions.values.updateTimer, name="updateMissions", repeatable=1, ms=false, action=moMissions.load} ); 
		else
			moMissions:load();
		end;
	end;
end;

function moMissions:load()
	moMissions:loadMissions();	
end;

function moMissions:loadMissions()
	local playerFarmId = g_currentMission.player.farmId;	
	moMissions.values.missions = {}; --new
	if g_missionManager.missions ~= nil and #g_missionManager.missions > 0 then
		for index=1, #g_missionManager.missions do			
			moMissions.values.missions[index] = {};
			moMissions.values.missions[index].object = g_missionManager.missions[index];
			local mission = g_missionManager.missions[index];			
			if mission.field ~= nil then				
				moMissions.values.missions[index].field = mission.field;
				moMissions.values.missions[index].fieldHectar = mission.field.fieldArea;
				moMissions.values.missions[index].fieldId = mission.field.fieldId;
				moMissions.values.missions[index].fillType = Utils.getNoNil(mission.fillType, nil);
				if moMissions.values.missions[index].fillType == nil and mission.fruitType ~= nil then 
					local fruitType = Utils.getNoNil(mission.fruitType, nil);
					if fruitType ~= nil then 
						local fillType = g_fruitTypeManager.fruitTypeIndexToFillType[fruitType];					
						if fillType ~= nil then
							moMissions.values.missions[index].fillType = Utils.getNoNil(fillType.index, nil)
						else					
							moMissions.values.missions[index].fillType = Utils.getNoNil(mission.fruitType, nil);
						end;
					end;
				end; --sow
				if MultiOverlayV3.otherMods.betterContracts == nil and moMissions.values.fieldToMission[mission.field.fieldId] == nil then moMissions.values.fieldToMission[mission.field.fieldId] = mission;end;
			else
				moMissions.values.missions[index].fieldHectar = 0;
				moMissions.values.missions[index].fieldId = 0;
			end;
			if mission.sellPoint ~= nil then
				moMissions.values.missions[index].sellPointId = mission.sellPoint.rootNode			
			end;
			moMissions.values.missions[index].reward = mission.reward;
			moMissions.values.missions[index].isRunning = mission.isInMissionMap or (mission.activeMissionId ~= nil);
			moMissions.values.missions[index].farmId = Utils.getNoNil(mission.farmId, 0);
			if mission.type ~= nil then
				moMissions.values.missions[index].typeId = Utils.getNoNil(mission.type.typeId,0);
				moMissions.values.missions[index].className = Utils.getNoNil(mission.type.class.className, "Unknown");
				moMissions.values.missions[index].typeName = Utils.getNoNil(mission.type.name, "Unknown");
			else
				moMissions.values.missions[index].typeId = 0;
				moMissions.values.missions[index].className = "Unknown";
				moMissions.values.missions[index].typeName = "Unknown";
			end;
			moMissions.values.missions[index].missionId = Utils.getNoNil(mission.id, 0);
			moMissions.values.missions[index].activeId = Utils.getNoNil(mission.activeMissionId, 0);
			moMissions.values.missions[index].prozent = g_i18n:formatNumber(Utils.getNoNil(mission.completion, 0)*100);
			moMissions.values.missions[index].numObjects = Utils.getNoNil(mission.numObjects, 0);
			moMissions.values.missions[index].status = mission.status;
			moMissions.values.missions[index].isLeasing = Utils.getNoNil(mission.spawnedVehicles, false); --SP <--Giants Problem with MP Event(kann nur noch über Vehicle dann abgefragt werden)			
			--local hasLeasing = mission:hasLeasableVehicles();
			--if not moMissions.values.missions[index].isLeasing then moMissions.values.missions[index].isLeasing = mission.vehiclesToLoad ~= nil;end; --MP
		end;		
		function reward(w1,w2)			
			if w1.reward > w2.reward then
				return true;
			end;			
		end;
		function typeId(w1,w2)			
			if w1.typeId > w2.typeId then
				return true;
			end;			
		end;
		function hectar(w1,w2)			
			if w1.fieldHectar > w2.fieldHectar then
				return true;
			end;			
		end;
		function fieldId(w1,w2)			
			if w1.fieldId > w2.fieldId then
				return true;
			end;			
		end;
		if moMissions.values.sortBy == 1 then
			table.sort(moMissions.values.missions, reward);
		elseif 	moMissions.values.sortBy == 2 then
			table.sort(moMissions.values.missions, typeId);
		elseif 	moMissions.values.sortBy == 3 then
			table.sort(moMissions.values.missions, hectar);
		elseif 	moMissions.values.sortBy == 4 then
			table.sort(moMissions.values.missions, fieldId);	
		end;		
	end;
end;
