moObjectStorages = {};
source(MultiOverlayV3.modDir.."scripte/module/objectstorages/moObjectStoragesConfig.lua");

function moObjectStorages:update(dt)
	if moModule.active.objectstorages.isRunning then
		if moObjectStorages.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateObjectStorages"] ~= nil then return;end; 
			moSetGetExtras:addTimer( {delay=moObjectStorages.values.updateTimer, name="updateObjectStorages", repeatable=1, ms=moObjectStorages.values.msec, action=moObjectStorages.loadObjectStorages} )
		else
			moObjectStorages:loadObjectStorages();
		end;
	end;
end;

function moObjectStorages:loadObjectStorages()	
	moObjectStorages:loadObjectStorages();	
end;

function moObjectStorages:loadObjectStorages()	
	local playerFarmId = g_currentMission.player.farmId;
	moObjectStorages.values.storages = {}; --new
	if moModule.objectStorages ~= nil and #moModule.objectStorages > 0 then
		local deleteObject = {};
		for index=1, #moModule.objectStorages do			
			if moModule.objectStorages[index] ~= nil then
				local isObject = moModule:isObject(moModule.objectStorages[index].object, true);
				if isObject then
					local objectstorage = moModule.objectStorages[index].object;					
					if objectstorage.ownerFarmId == 0 or objectstorage.ownerFarmId == playerFarmId then
						local objectstorageName = moModule.objectStorages[index].xmlName;
						if moObjectStorages.values.storages[objectstorageName] == nil then moObjectStorages.values.storages[objectstorageName] = {};end;
						moObjectStorages.values.storages[objectstorageName][#moObjectStorages.values.storages[objectstorageName]+1] = {general={},output={},input={}};
						---
						local lineTableGeneral = moObjectStorages.values.storages[objectstorageName][#moObjectStorages.values.storages[objectstorageName]].general;
						lineTableGeneral[#lineTableGeneral+1] = {};
						local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];						
						isLineTableGeneral.object = objectstorage;
						isLineTableGeneral.ownerFarmId = objectstorage.ownerFarmId or 0;
						isLineTableGeneral.objectName = moModule.objectStorages[index].name;
						if moModule.objectStorages[index].mohDisplayName ~= nil then isLineTableGeneral.objectName = moModule.objectStorages[index].mohDisplayName;end;
						isLineTableGeneral.xmlName = objectstorageName;
						---
						if objectstorage.storageAreas ~= nil then
							local lineTableOutput = moObjectStorages.values.storages[objectstorageName][#moObjectStorages.values.storages[objectstorageName]].output;
							lineTableOutput[#lineTableOutput+1] = {};
							local isLineTableOutput = lineTableOutput[#lineTableOutput];
							local capacity, fillLevel, fillTypesTotal = moObjectStorages:getFillTypeLevels(objectstorage.storageAreas);
							local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];
							if objectstorage.isBaleStorage then
								--fillType_squareBale,fillType_roundBale
								local baleTyp = g_i18n:getText("fillType_squareBale");
								if objectstorage.isRoundBaleStorage then baleTyp = g_i18n:getText("fillType_roundBale");end;
								if fillType ~= nil then 
									isLineTableOutput.fillTypeName = fillType.name.. " ".. moLanguageXml:getTxt("bale", nil, g_i18n:getText("category_bales"));
									isLineTableOutput.fillTypeRegName = fillType.regName;
								else
									isLineTableOutput.fillTypeName = baleTyp;									
								end;
							else
								if fillType ~= nil then 
									isLineTableOutput.fillTypeName = fillType.name.. " ".. moLanguageXml:getTxt("pallets", nil, g_i18n:getText("category_pallets"));
									isLineTableOutput.fillTypeRegName = fillType.regName;
								else
									isLineTableOutput.fillTypeName = moLanguageXml:getTxt("pallets", nil, g_i18n:getText("category_pallets"));									
								end;
							end;
							isLineTableOutput.fillTypesTotal = fillTypesTotal;
							isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
							isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
							isLineTableOutput.percentageCapacity = math.floor(100 * (Utils.getNoNil(fillLevel,0)/Utils.getNoNil(capacity,0))); --g_i18n:formatNumber(Utils.getNoNil(fillLevel/capacity, 0)*100);
						end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.objectStorages, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;
end;

function moObjectStorages:getFillTypeLevels(fillTypeModule)
	local fillLevelTotal = 0;
	local fillTypesTotal = {};
	local capacityTotal = 0;
	if fillTypeModule ~= nil and type(fillTypeModule) == "table" then
		for _, fillType in pairs(fillTypeModule) do
			fillLevelTotal = fillLevelTotal+Utils.getNoNil(#fillType.storedObjects, 0);
			capacityTotal = capacityTotal+fillType.capacity;
			table.insert(fillTypesTotal, fillType);
		end;
	end;
	return capacityTotal, fillLevelTotal, fillTypesTotal;
end;